diff --git a/drivers/usb/host/xhci-pci-renesas.c b/drivers/usb/host/xhci-pci-renesas.c
index 93f8b355bc70..28656beb808d 100644
--- a/drivers/usb/host/xhci-pci-renesas.c
+++ b/drivers/usb/host/xhci-pci-renesas.c
@@ -375,199 +375,11 @@ static int renesas_fw_download(struct pci_dev *pdev,
 	return 0;
 }
 
-static void renesas_rom_erase(struct pci_dev *pdev)
-{
-	int retval, i;
-	u8 status;
-
-	dev_dbg(&pdev->dev, "Performing ROM Erase...\n");
-	retval = pci_write_config_dword(pdev, RENESAS_DATA0,
-					RENESAS_ROM_ERASE_MAGIC);
-	if (retval) {
-		dev_err(&pdev->dev, "ROM erase, magic word write failed: %d\n",
-			pcibios_err_to_errno(retval));
-		return;
-	}
-
-	retval = pci_read_config_byte(pdev, RENESAS_ROM_STATUS, &status);
-	if (retval) {
-		dev_err(&pdev->dev, "ROM status read failed: %d\n",
-			pcibios_err_to_errno(retval));
-		return;
-	}
-	status |= RENESAS_ROM_STATUS_ERASE;
-	retval = pci_write_config_byte(pdev, RENESAS_ROM_STATUS, status);
-	if (retval) {
-		dev_err(&pdev->dev, "ROM erase set word write failed\n");
-		return;
-	}
-
-	/* sleep a bit while ROM is erased */
-	msleep(20);
-
-	for (i = 0; i < RENESAS_RETRY; i++) {
-		retval = pci_read_config_byte(pdev, RENESAS_ROM_STATUS,
-					      &status);
-		status &= RENESAS_ROM_STATUS_ERASE;
-		if (!status)
-			break;
-
-		mdelay(RENESAS_DELAY);
-	}
-
-	if (i == RENESAS_RETRY)
-		dev_dbg(&pdev->dev, "Chip erase timedout: %x\n", status);
-
-	dev_dbg(&pdev->dev, "ROM Erase... Done success\n");
-}
-
-static bool renesas_setup_rom(struct pci_dev *pdev, const struct firmware *fw)
-{
-	const u32 *fw_data = (const u32 *)fw->data;
-	int err, i;
-	u8 status;
-
-	/* 2. Write magic word to Data0 */
-	err = pci_write_config_dword(pdev, RENESAS_DATA0,
-				     RENESAS_ROM_WRITE_MAGIC);
-	if (err)
-		return false;
-
-	/* 3. Set External ROM access */
-	err = pci_write_config_byte(pdev, RENESAS_ROM_STATUS,
-				    RENESAS_ROM_STATUS_ACCESS);
-	if (err)
-		goto remove_bypass;
-
-	/* 4. Check the result */
-	err = pci_read_config_byte(pdev, RENESAS_ROM_STATUS, &status);
-	if (err)
-		goto remove_bypass;
-	status &= GENMASK(6, 4);
-	if (status) {
-		dev_err(&pdev->dev,
-			"setting external rom failed: %x\n", status);
-		goto remove_bypass;
-	}
-
-	/* 5 to 16 Write FW to DATA0/1 while checking SetData0/1 */
-	for (i = 0; i < fw->size / 4; i++) {
-		err = renesas_fw_download_image(pdev, fw_data, i, true);
-		if (err) {
-			dev_err(&pdev->dev,
-				"ROM Download Step %d failed at position %d bytes with (%d)\n",
-				 i, i * 4, err);
-			goto remove_bypass;
-		}
-	}
-
-	/*
-	 * wait till DATA0/1 is cleared
-	 */
-	for (i = 0; i < RENESAS_RETRY; i++) {
-		err = pci_read_config_byte(pdev, RENESAS_ROM_STATUS_MSB,
-					   &status);
-		if (err)
-			goto remove_bypass;
-		if (!(status & (BIT(0) | BIT(1))))
-			break;
-
-		udelay(RENESAS_DELAY);
-	}
-	if (i == RENESAS_RETRY) {
-		dev_err(&pdev->dev, "Final Firmware ROM Download step timed out\n");
-		goto remove_bypass;
-	}
-
-	/* 17. Remove bypass */
-	err = pci_write_config_byte(pdev, RENESAS_ROM_STATUS, 0);
-	if (err)
-		return false;
-
-	udelay(10);
-
-	/* 18. check result */
-	for (i = 0; i < RENESAS_RETRY; i++) {
-		err = pci_read_config_byte(pdev, RENESAS_ROM_STATUS, &status);
-		if (err) {
-			dev_err(&pdev->dev, "Read ROM status failed:%d\n",
-				pcibios_err_to_errno(err));
-			return false;
-		}
-		status &= RENESAS_ROM_STATUS_RESULT;
-		if (status ==  RENESAS_ROM_STATUS_SUCCESS) {
-			dev_dbg(&pdev->dev, "Download ROM success\n");
-			break;
-		}
-		udelay(RENESAS_DELAY);
-	}
-	if (i == RENESAS_RETRY) { /* Timed out */
-		dev_err(&pdev->dev,
-			"Download to external ROM TO: %x\n", status);
-		return false;
-	}
-
-	dev_dbg(&pdev->dev, "Download to external ROM succeeded\n");
-
-	/* Last step set Reload */
-	err = pci_write_config_byte(pdev, RENESAS_ROM_STATUS,
-				    RENESAS_ROM_STATUS_RELOAD);
-	if (err) {
-		dev_err(&pdev->dev, "Set ROM execute failed: %d\n",
-			pcibios_err_to_errno(err));
-		return false;
-	}
-
-	/*
-	 * wait till Reload is cleared
-	 */
-	for (i = 0; i < RENESAS_RETRY; i++) {
-		err = pci_read_config_byte(pdev, RENESAS_ROM_STATUS, &status);
-		if (err)
-			return false;
-		if (!(status & RENESAS_ROM_STATUS_RELOAD))
-			break;
-
-		udelay(RENESAS_DELAY);
-	}
-	if (i == RENESAS_RETRY) {
-		dev_err(&pdev->dev, "ROM Exec timed out: %x\n", status);
-		return false;
-	}
-
-	return true;
-
-remove_bypass:
-	pci_write_config_byte(pdev, RENESAS_ROM_STATUS, 0);
-	return false;
-}
-
 static int renesas_load_fw(struct pci_dev *pdev, const struct firmware *fw)
 {
 	int err = 0;
-	bool rom;
-
-	/* Check if the device has external ROM */
-	rom = renesas_check_rom(pdev);
-	if (rom) {
-		/* perform chip erase first */
-		renesas_rom_erase(pdev);
-
-		/* lets try loading fw on ROM first */
-		rom = renesas_setup_rom(pdev, fw);
-		if (!rom) {
-			dev_dbg(&pdev->dev,
-				"ROM load failed, falling back on FW load\n");
-		} else {
-			dev_dbg(&pdev->dev,
-				"ROM load success\n");
-			goto exit;
-		}
-	}
 
 	err = renesas_fw_download(pdev, fw);
-
-exit:
 	if (err)
 		dev_err(&pdev->dev, "firmware failed to download (%d).", err);
 	return err;